## incus 6.0.0

=== Makefile ===
GO ?= go
DOMAIN=incus
POFILES=$(wildcard po/*.po)
MOFILES=$(patsubst %.po,%.mo,$(POFILES))
LINGUAS=$(basename $(POFILES))
POTFILE=po/$(DOMAIN).pot
VERSION=$(or ${CUSTOM_VERSION},$(shell grep "var Version" internal/version/flex.go | cut -d'"' -f2))
ARCHIVE=incus-$(VERSION).tar
HASH := \#
TAG_SQLITE3=$(shell printf "$(HASH)include <cowsql.h>\nvoid main(){cowsql_node_id n = 1;}" | $(CC) ${CGO_CFLAGS} -o /dev/null -xc - >/dev/null 2>&1 && echo "libsqlite3")
GOPATH ?= $(shell $(GO) env GOPATH)
CGO_LDFLAGS_ALLOW ?= (-Wl,-wrap,pthread_create)|(-Wl,-z,now)
SPHINXENV=doc/.sphinx/venv/bin/activate
SPHINXPIPPATH=doc/.sphinx/venv/bin/pip
OVN_MINVER=22.03.0
OVS_MINVER=2.15.0

ifneq "$(wildcard vendor)" ""
	RAFT_PATH=$(CURDIR)/vendor/raft
	COWSQL_PATH=$(CURDIR)/vendor/cowsql
else
	RAFT_PATH=$(GOPATH)/deps/raft
	COWSQL_PATH=$(GOPATH)/deps/cowsql
endif

	# raft
.PHONY: default
default: build

.PHONY: build
build:
ifeq "$(TAG_SQLITE3)" ""
	@echo "Missing cowsql, run \"make deps\" to setup."
	exit 1
endif

	CC="$(CC)" CGO_LDFLAGS_ALLOW="$(CGO_LDFLAGS_ALLOW)" $(GO) install -v -tags "$(TAG_SQLITE3)" $(DEBUG) ./...
	CGO_ENABLED=0 $(GO) install -v -tags netgo ./cmd/incus-migrate
	CGO_ENABLED=0 $(GO) install -v -tags agent,netgo ./cmd/incus-agent
	@echo "Incus built successfully"

.PHONY: client
client:
	$(GO) install -v -tags "$(TAG_SQLITE3)" $(DEBUG) ./cmd/incus
	@echo "Incus client built successfully"

.PHONY: incus-agent
incus-agent:
	CGO_ENABLED=0 $(GO) install -v -tags agent,netgo ./cmd/incus-agent
	@echo "Incus agent built successfully"

.PHONY: incus-migrate
incus-migrate:
	CGO_ENABLED=0 $(GO) install -v -tags netgo ./cmd/incus-migrate
	@echo "Incus migration tool built successfully"

.PHONY: deps
deps:
	@if [ ! -e "$(RAFT_PATH)" ]; then \
		git clone --depth=1 "https://github.com/cowsql/raft" "$(RAFT_PATH)"; \
	elif [ -e "$(RAFT_PATH)/.git" ]; then \
		cd "$(RAFT_PATH)"; git pull; \
	fi

	cd "$(RAFT_PATH)" && \
		autoreconf -i && \
		./configure && \
		make

	# cowsql
	@if [ ! -e "$(COWSQL_PATH)" ]; then \
		git clone --depth=1 "https://github.com/cowsql/cowsql" "$(COWSQL_PATH)"; \
	elif [ -e "$(COWSQL_PATH)/.git" ]; then \
		cd "$(COWSQL_PATH)"; git pull; \
	fi

	cd "$(COWSQL_PATH)" && \
		autoreconf -i && \
		PKG_CONFIG_PATH="$(RAFT_PATH)" ./configure && \
		make CFLAGS="-I$(RAFT_PATH)/include/" LDFLAGS="-L$(RAFT_PATH)/.libs/"

	# environment
	@echo ""
	@echo "Please set the following in your environment (possibly ~/.bashrc)"
	@echo "export CGO_CFLAGS=\"-I$(RAFT_PATH)/include/ -I$(COWSQL_PATH)/include/\""
	@echo "export CGO_LDFLAGS=\"-L$(RAFT_PATH)/.libs -L$(COWSQL_PATH)/.libs/\""
	@echo "export LD_LIBRARY_PATH=\"$(RAFT_PATH)/.libs/:$(COWSQL_PATH)/.libs/\""
	@echo "export CGO_LDFLAGS_ALLOW=\"(-Wl,-wrap,pthread_create)|(-Wl,-z,now)\""

.PHONY: update-gomod
update-gomod:
ifneq "$(INCUS_OFFLINE)" ""
	@echo "The update-gomod target cannot be run in offline mode."
	exit 1
endif
	$(GO) get -t -v -d -u ./...
	$(GO) get github.com/cenkalti/rpc2@v1.0.1
	$(GO) mod tidy --go=1.21
	$(GO) get toolchain@none

	cd test/mini-oidc && $(GO) get -t -v -d -u ./...
	cd test/mini-oidc && $(GO) mod tidy --go=1.21
	@echo "Dependencies updated"

.PHONY: update-ovsdb
update-ovsdb:
	go install github.com/ovn-org/libovsdb/cmd/modelgen@main

	rm -Rf internal/server/network/ovs/schema
	mkdir internal/server/network/ovs/schema
	curl -s https://raw.githubusercontent.com/openvswitch/ovs/v$(OVS_MINVER)/vswitchd/vswitch.ovsschema -o internal/server/network/ovs/schema/ovs.json
	modelgen -o internal/server/network/ovs/schema/ovs internal/server/network/ovs/schema/ovs.json
	rm internal/server/network/ovs/schema/*.json

	rm -Rf internal/server/network/ovn/schema
	mkdir internal/server/network/ovn/schema
	curl -s https://raw.githubusercontent.com/ovn-org/ovn/v$(OVN_MINVER)/ovn-nb.ovsschema -o internal/server/network/ovn/schema/ovn-nb.json
	curl -s https://raw.githubusercontent.com/ovn-org/ovn/v$(OVN_MINVER)/ovn-sb.ovsschema -o internal/server/network/ovn/schema/ovn-sb.json
	curl -s https://raw.githubusercontent.com/ovn-org/ovn/v$(OVN_MINVER)/ovn-ic-nb.ovsschema -o internal/server/network/ovn/schema/ovn-ic-nb.json
	curl -s https://raw.githubusercontent.com/ovn-org/ovn/v$(OVN_MINVER)/ovn-ic-sb.ovsschema -o internal/server/network/ovn/schema/ovn-ic-sb.json
	modelgen -o internal/server/network/ovn/schema/ovn-nb internal/server/network/ovn/schema/ovn-nb.json
	modelgen -o internal/server/network/ovn/schema/ovn-sb internal/server/network/ovn/schema/ovn-sb.json
	modelgen -o internal/server/network/ovn/schema/ovn-ic-nb internal/server/network/ovn/schema/ovn-ic-nb.json
	modelgen -o internal/server/network/ovn/schema/ovn-ic-sb internal/server/network/ovn/schema/ovn-ic-sb.json
	rm internal/server/network/ovn/schema/*.json

.PHONY: update-protobuf
update-protobuf:
	protoc --go_out=. ./internal/migration/migrate.proto

.PHONY: update-schema
update-schema:
	cd internal/server/db/generate && $(GO) build -o $(GOPATH)/bin/incus-generate -tags "$(TAG_SQLITE3)" $(DEBUG) && cd -
	$(GO) generate ./...
	gofmt -s -w ./internal/server/db/
	goimports -w ./internal/server/db/
	@echo "Code generation completed"

.PHONY: update-api
update-api:
ifeq "$(INCUS_OFFLINE)" ""
	(cd / ; $(GO) install -v -x github.com/go-swagger/go-swagger/cmd/swagger@latest)
endif
	swagger generate spec -o doc/rest-api.yaml -w ./cmd/incusd -m

.PHONY: update-metadata
update-metadata: build
	@echo "Generating golang documentation metadata"
	cd internal/server/config/generate && CGO_ENABLED=0 $(GO) build -o $(GOPATH)/bin/incus-doc
	$(GOPATH)/bin/incus-doc . --json ./internal/server/metadata/configuration.json --txt ./doc/config_options.txt

.PHONY: doc-setup
doc-setup: client
	@echo "Setting up documentation build environment"
	python3 -m venv doc/.sphinx/venv
	. $(SPHINXENV) ; pip install --require-virtualenv --upgrade -r doc/.sphinx/requirements.txt --log doc/.sphinx/venv/pip_install.log
	@test ! -f doc/.sphinx/venv/pip_list.txt || \
        mv doc/.sphinx/venv/pip_list.txt doc/.sphinx/venv/pip_list.txt.bak
	$(SPHINXPIPPATH) list --local --format=freeze > doc/.sphinx/venv/pip_list.txt
	find doc/reference/manpages/ -name "*.md" -type f -delete
	rm -Rf doc/html
	rm -Rf doc/.sphinx/.doctrees

.PHONY: doc
doc: doc-setup doc-incremental

.PHONY: doc-incremental
doc-incremental:
	@echo "Build the documentation"
	. $(SPHINXENV) ; sphinx-build -c doc/ -b dirhtml doc/ doc/html/ -d doc/.sphinx/.doctrees -w doc/.sphinx/warnings.txt

.PHONY: doc-serve
doc-serve:
	cd doc/html; python3 -m http.server 8001

.PHONY: doc-spellcheck
doc-spellcheck: doc
	. $(SPHINXENV) ; python3 -m pyspelling -c doc/.sphinx/spellingcheck.yaml

.PHONY: doc-linkcheck
doc-linkcheck: doc-setup
	. $(SPHINXENV) ; LOCAL_SPHINX_BUILD=True sphinx-build -c doc/ -b linkcheck doc/ doc/html/ -d doc/.sphinx/.doctrees

.PHONY: doc-lint
doc-lint:
	doc/.sphinx/.markdownlint/doc-lint.sh

.PHONY:  woke-install
woke-install:
	@type woke >/dev/null 2>&1 || \
        { echo "Installing \"woke\" snap... \n"; sudo snap install woke; }

.PHONY: doc-woke
doc-woke: woke-install
	woke *.md **/*.md -c https://github.com/canonical/Inclusive-naming/raw/main/config.yml

.PHONY: debug
debug:
ifeq "$(TAG_SQLITE3)" ""
	@echo "Missing custom libsqlite3, run \"make deps\" to setup."
	exit 1
endif

	CC="$(CC)" CGO_LDFLAGS_ALLOW="$(CGO_LDFLAGS_ALLOW)" $(GO) install -v -tags "$(TAG_SQLITE3) logdebug" $(DEBUG) ./...
	CGO_ENABLED=0 $(GO) install -v -tags "netgo,logdebug" ./cmd/incus-migrate
	CGO_ENABLED=0 $(GO) install -v -tags "agent,netgo,logdebug" ./cmd/incus-agent
	@echo "Incus built successfully"

.PHONY: nocache
nocache:
ifeq "$(TAG_SQLITE3)" ""
	@echo "Missing custom libsqlite3, run \"make deps\" to setup."
	exit 1
endif

	CC="$(CC)" CGO_LDFLAGS_ALLOW="$(CGO_LDFLAGS_ALLOW)" $(GO) install -a -v -tags "$(TAG_SQLITE3)" $(DEBUG) ./...
	CGO_ENABLED=0 $(GO) install -a -v -tags netgo ./cmd/incus-migrate
	CGO_ENABLED=0 $(GO) install -a -v -tags agent,netgo ./cmd/incus-agent
	@echo "Incus built successfully"

race:
ifeq "$(TAG_SQLITE3)" ""
	@echo "Missing custom libsqlite3, run \"make deps\" to setup."
	exit 1
endif

	CC="$(CC)" CGO_LDFLAGS_ALLOW="$(CGO_LDFLAGS_ALLOW)" $(GO) install -race -v -tags "$(TAG_SQLITE3)" $(DEBUG) ./...
	CGO_ENABLED=0 $(GO) install -v -tags netgo ./cmd/incus-migrate
	CGO_ENABLED=0 $(GO) install -v -tags agent,netgo ./cmd/incus-agent
	@echo "Incus built successfully"

.PHONY: check
check: default
ifeq "$(INCUS_OFFLINE)" ""
	(cd / ; $(GO) install -v -x github.com/rogpeppe/godeps@latest)
	(cd / ; $(GO) install -v -x github.com/tsenart/deadcode@latest)
	(cd / ; $(GO) install -v -x golang.org/x/lint/golint@latest)
endif
	CGO_LDFLAGS_ALLOW="$(CGO_LDFLAGS_ALLOW)" $(GO) test -v -tags "$(TAG_SQLITE3)" $(DEBUG) ./...
	cd test && ./main.sh

.PHONY: dist
dist: doc
	# Cleanup
	rm -Rf $(ARCHIVE).xz

	# Create build dir
	$(eval TMP := $(shell mktemp -d))
	git archive --prefix=incus-$(VERSION)/ HEAD | tar -x -C $(TMP)
	git show-ref HEAD | cut -d' ' -f1 > $(TMP)/incus-$(VERSION)/.gitref

	# Download dependencies
	(cd $(TMP)/incus-$(VERSION) ; $(GO) mod vendor)

	# Download the cowsql libraries
	git clone --depth=1 https://github.com/cowsql/cowsql $(TMP)/incus-$(VERSION)/vendor/cowsql
	(cd $(TMP)/incus-$(VERSION)/vendor/cowsql ; git show-ref HEAD | cut -d' ' -f1 > .gitref)

	git clone --depth=1 https://github.com/cowsql/raft $(TMP)/incus-$(VERSION)/vendor/raft
	(cd $(TMP)/incus-$(VERSION)/vendor/raft ; git show-ref HEAD | cut -d' ' -f1 > .gitref)

	# Copy doc output
	cp -r doc/html $(TMP)/incus-$(VERSION)/doc/html/

	# Assemble tarball
	tar --exclude-vcs -C $(TMP) -Jcf $(ARCHIVE).xz incus-$(VERSION)/

	# Cleanup
	rm -Rf $(TMP)

.PHONY: i18n
i18n: update-pot update-po

po/%.mo: po/%.po
	msgfmt --statistics -o $@ $<

po/%.po: po/$(DOMAIN).pot
	msgmerge -U po/$*.po po/$(DOMAIN).pot

.PHONY: update-po
update-po:
	set -eu; \
	for lang in $(LINGUAS); do\
	    msgmerge --backup=none -U $$lang.po po/$(DOMAIN).pot; \
	done

.PHONY: update-pot
update-pot:
ifeq "$(INCUS_OFFLINE)" ""
	(cd / ; $(GO) install -v -x github.com/snapcore/snapd/i18n/xgettext-go@2.57.1)
endif
	xgettext-go -o po/$(DOMAIN).pot --add-comments-tag=TRANSLATORS: --sort-output --package-name=$(DOMAIN) --msgid-bugs-address=lxc-devel@lists.linuxcontainers.org --keyword=i18n.G --keyword-plural=i18n.NG cmd/incus/*.go shared/cliconfig/*.go

.PHONY: build-mo
build-mo: $(MOFILES)

.PHONY: static-analysis
static-analysis:
ifeq ($(shell command -v go-licenses),)
	(cd / ; $(GO) install -v -x github.com/google/go-licenses@latest)
endif
ifeq ($(shell command -v golangci-lint),)
	curl -sSfL https://raw.githubusercontent.com/golangci/golangci-lint/master/install.sh | sh -s -- -b $$($(GO) env GOPATH)/bin
endif
ifeq ($(shell command -v shellcheck),)
	echo "Please install shellcheck"
	exit 1
else
endif
ifeq ($(shell command -v flake8),)
	echo "Please install flake8"
	exit 1
endif
	flake8 test/deps/import-busybox
	shellcheck --shell sh test/*.sh test/includes/*.sh test/suites/*.sh test/backends/*.sh test/lint/*.sh
	shellcheck test/extras/*.sh
	run-parts --exit-on-error --regex '.sh' test/lint

.PHONY: staticcheck
staticcheck:
ifeq ($(shell command -v staticcheck),)
	(cd / ; $(GO) install -v -x honnef.co/go/tools/cmd/staticcheck@latest)
endif
	# To get advance notice of deprecated function usage, consider running:
	#   sed -i 's/^go 1\.[0-9]\+$/go 1.18/' go.mod
	# before 'make staticcheck'.

	# Run staticcheck against all the dirs containing Go files.
	staticcheck $$(git ls-files *.go | sed 's|^|./|; s|/[^/]\+\.go$$||' | sort -u)

tags: */*.go
	find . -type f -name '*.go' | gotags -L - -f tags

# OpenFGA Syntax Transformer: https://github.com/openfga/syntax-transformer
.PHONY: update-openfga
update-openfga:
	@printf 'package auth\n\n// Code generated by Makefile; DO NOT EDIT.\n\nvar authModel = `%s`\n' '$(shell npx --yes @openfga/syntax-transformer transform --from=dsl --inputFile=./internal/server/auth/driver_openfga_model.openfga | jq -c)' > ./internal/server/auth/driver_openfga_model.go

=== debian/changelog ===
incus (6.0.0-1) unstable; urgency=medium

  * New upstream release
    - Ship shell completions for bash, fish, and zsh
  * d/control:
    - Update minimum major version of golang-github-zitadel-oidc
    - Update Standards-Version to 4.7.0 (no changes needed)

 -- Mathias Gibbens <gibmat@debian.org>  Thu, 11 Apr 2024 01:01:17 +0000

incus (0.7-1) unstable; urgency=medium

  * New upstream release
    - Update Build-Depends and Depends
    - Package incus-simplestreams in bin:incus-tools
    - Don't build tls2jwt test binary
  * Sync incus-agent scripts with upstream (See #1064213)

 -- Mathias Gibbens <gibmat@debian.org>  Tue, 26 Mar 2024 23:03:26 +0000

incus (0.6-2) unstable; urgency=medium

  * Fix incus-agent injection if $PATH is set in /etc/environment
    (Closes: #1065174)
  * d/control:
    - Add Depends on iproute2 (Closes: #1064852)
    - Suggest bash-completion in incus-client
    - Set minimum version of golang to aid backporting
  * d/rules:
    - Remove unneeded override of dh_installinit
  * Don't print install message on upgrades

 -- Mathias Gibbens <gibmat@debian.org>  Wed, 06 Mar 2024 02:48:38 +0000

incus (0.6-1) unstable; urgency=medium

  * New upstream release
    - Update Build-Depends and Depends

 -- Mathias Gibbens <gibmat@debian.org>  Thu, 22 Feb 2024 23:24:32 +0000

incus (0.5.1-3) unstable; urgency=medium

  * Source-only upload for migration
  * Drop lintian overrides for removed tag
    package-supports-alternative-init-but-no-init.d-script

 -- Mathias Gibbens <gibmat@debian.org>  Mon, 12 Feb 2024 10:34:51 +0000

incus (0.5.1-2) unstable; urgency=medium

  * Add a golang-github-lxc-incus-dev package

 -- Mathias Gibbens <gibmat@debian.org>  Sat, 03 Feb 2024 14:34:36 +0000

incus (0.5.1-1) unstable; urgency=medium

  * New upstream release

 -- Mathias Gibbens <gibmat@debian.org>  Mon, 29 Jan 2024 20:31:42 +0000

incus (0.5-1) unstable; urgency=medium

  * New upstream release:
    - Drop patches applied upstream
    - Drop patch that disabled Loki integration and update d/README.debian
    - Update Build-Depends and Depends
  * Update years in d/copyright
  * d/rules:
    - Update list of files and directories set in DH_GOLANG_INSTALL_EXTRA
    - Set HOME environment variable for all manpage generation commands
  * Rename d/README.debian -> d/README.Debian

 -- Mathias Gibbens <gibmat@debian.org>  Fri, 26 Jan 2024 01:06:09 +0000

incus (0.4-1) unstable; urgency=medium

  * Initial release (Closes: #1042989)

 -- Mathias Gibbens <gibmat@debian.org>  Fri, 12 Jan 2024 17:21:36 +0000

=== debian/control ===
Source: incus
Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
Uploaders: Free Ekanayaka <freee@debian.org>, Mathias Gibbens <gibmat@debian.org>
Section: admin
Testsuite: autopkgtest-pkg-go
Priority: optional
Build-Depends: debhelper-compat (= 13),
               dh-golang,
               golang-any (>= 2:1.21~),
               golang-github-armon-go-proxyproto-dev,
               golang-github-checkpoint-restore-go-criu-dev (>= 6.3.0),
               golang-github-cowsql-go-cowsql-dev,
               golang-github-digitalocean-go-qemu-dev,
               golang-github-digitalocean-go-smbios-dev,
               golang-github-dustinkirkland-golang-petname-dev,
               golang-github-flosch-pongo2.v4-dev,
               golang-github-fvbommel-sortorder-dev,
               golang-github-go-logr-logr-dev,
               golang-github-golang-jwt-jwt-v5-dev,
               golang-github-golang-protobuf-1-5-dev,
               golang-github-google-gopacket-dev,
               golang-github-google-uuid-dev,
               golang-github-gorilla-mux-dev,
               golang-github-gorilla-websocket-dev,
               golang-github-gosexy-gettext-dev,
               golang-github-j-keck-arping-dev,
               golang-github-jaypipes-pcidb-dev,
               golang-github-jochenvg-go-udev-dev,
               golang-github-kballard-go-shellquote-dev,
               golang-github-mattn-go-colorable-dev,
               golang-github-mattn-go-sqlite3-dev,
               golang-github-mdlayher-ndp-dev,
               golang-github-mdlayher-netx-dev,
               golang-github-mdlayher-vsock-dev,
               golang-github-miekg-dns-dev,
               golang-github-minio-madmin-go-dev (>= 3.0.38),
               golang-github-minio-minio-go-v7-dev,
               golang-github-mitchellh-mapstructure-dev,
               golang-github-olekukonko-tablewriter-dev,
               golang-github-openfga-go-sdk-dev,
               golang-github-osrg-gobgp-dev (>= 3.10.0),
               golang-github-ovn-org-libovsdb-dev,
               golang-github-pierrec-lz4-dev (>= 4.1.18),
               golang-github-pkg-sftp-dev,
               golang-github-pkg-xattr-dev,
               golang-github-rican7-retry-dev,
               golang-github-robfig-cron-dev,
               golang-github-sirupsen-logrus-dev,
               golang-github-spf13-cobra-dev,
               golang-github-stretchr-testify-dev,
               golang-github-vishvananda-netlink-dev,
               golang-github-xenolf-lego-dev,
               golang-github-zitadel-oidc-dev (>= 3.0),
               golang-gocapability-dev,
               golang-golang-x-crypto-dev,
               golang-golang-x-oauth2-dev,
               golang-golang-x-sync-dev,
               golang-golang-x-sys-dev,
               golang-golang-x-term-dev,
               golang-golang-x-text-dev,
               golang-google-protobuf-dev,
               golang-gopkg-lxc-go-lxc.v2-dev,
               golang-gopkg-tomb.v2-dev,
               golang-gopkg-yaml.v2-dev,
               golang-k8s-utils-dev,
               golang-starlark-dev,
               help2man,
               libacl1-dev,
               libcap-dev
Build-Conflicts: golang-github-golang-protobuf-1-3-dev
Standards-Version: 4.7.0
Vcs-Browser: https://salsa.debian.org/go-team/packages/incus
Vcs-Git: https://salsa.debian.org/go-team/packages/incus.git
Homepage: https://linuxcontainers.org/incus/
Rules-Requires-Root: no
XS-Go-Import-Path: github.com/lxc/incus

Package: golang-github-lxc-incus-dev
Architecture: all
Multi-Arch: foreign
Section: golang
Depends: golang-github-armon-go-proxyproto-dev,
         golang-github-checkpoint-restore-go-criu-dev (>= 6.3.0),
         golang-github-cowsql-go-cowsql-dev,
         golang-github-digitalocean-go-qemu-dev,
         golang-github-digitalocean-go-smbios-dev,
         golang-github-dustinkirkland-golang-petname-dev,
         golang-github-flosch-pongo2.v4-dev,
         golang-github-fvbommel-sortorder-dev,
         golang-github-go-logr-logr-dev,
         golang-github-golang-jwt-jwt-v5-dev,
         golang-github-golang-protobuf-1-5-dev,
         golang-github-google-gopacket-dev,
         golang-github-google-uuid-dev,
         golang-github-gorilla-mux-dev,
         golang-github-gorilla-websocket-dev,
         golang-github-gosexy-gettext-dev,
         golang-github-j-keck-arping-dev,
         golang-github-jaypipes-pcidb-dev,
         golang-github-jochenvg-go-udev-dev,
         golang-github-kballard-go-shellquote-dev,
         golang-github-mattn-go-colorable-dev,
         golang-github-mattn-go-sqlite3-dev,
         golang-github-mdlayher-ndp-dev,
         golang-github-mdlayher-netx-dev,
         golang-github-mdlayher-vsock-dev,
         golang-github-miekg-dns-dev,
         golang-github-minio-madmin-go-dev (>= 3.0.38),
         golang-github-minio-minio-go-v7-dev,
         golang-github-mitchellh-mapstructure-dev,
         golang-github-olekukonko-tablewriter-dev,
         golang-github-openfga-go-sdk-dev,
         golang-github-osrg-gobgp-dev (>= 3.10.0),
         golang-github-ovn-org-libovsdb-dev,
         golang-github-pierrec-lz4-dev (>= 4.1.18),
         golang-github-pkg-sftp-dev,
         golang-github-pkg-xattr-dev,
         golang-github-rican7-retry-dev,
         golang-github-robfig-cron-dev,
         golang-github-sirupsen-logrus-dev,
         golang-github-spf13-cobra-dev,
         golang-github-stretchr-testify-dev,
         golang-github-vishvananda-netlink-dev,
         golang-github-xenolf-lego-dev,
         golang-github-zitadel-oidc-dev (>= 3.0),
         golang-gocapability-dev,
         golang-golang-x-crypto-dev,
         golang-golang-x-oauth2-dev,
         golang-golang-x-sync-dev,
         golang-golang-x-sys-dev,
         golang-golang-x-term-dev,
         golang-golang-x-text-dev,
         golang-google-protobuf-dev,
         golang-gopkg-lxc-go-lxc.v2-dev,
         golang-gopkg-tomb.v2-dev,
         golang-gopkg-yaml.v2-dev,
         golang-k8s-utils-dev,
         golang-starlark-dev,
         ${misc:Depends}
Description: Powerful system container and virtual machine manager - library
 Incus is a next generation system container and virtual machine manager.
 It offers a unified user experience around full Linux systems running
 inside containers or virtual machines.
 .
 This package contains the Incus source code for use in building other
 Debian packages -- normal users should not directly use this package in
 their regular development workflow. Rather, they should use `go get`.

Package: incus
Architecture: linux-any
Depends: ${misc:Depends},
         ${shlibs:Depends},
         attr,
         ca-certificates,
         liblxc-common,
         lxcfs,
         incus-client (= ${binary:Version}),
         iproute2,
         nftables | iptables,
         rsync,
         squashfs-tools,
         uidmap,
         xz-utils
Recommends: apparmor, dnsmasq-base, incus-agent
# First line of suggested packages will enable additional Incus storage backends
Suggests: btrfs-progs, ceph-common, lvm2, zfsutils-linux,
          incus-tools, gdisk
Built-Using: ${misc:Built-Using}
Description: Powerful system container and virtual machine manager - daemon
 Incus is a next generation system container and virtual machine manager.
 It offers a unified user experience around full Linux systems running
 inside containers or virtual machines.
 .
 It's image based with pre-made images available for a wide number of
 Linux distributions and is built around a very powerful, yet pretty
 simple, REST API.
 .
 This package contains the Incus daemon.

Package: incus-client
# The incus binary doesn't depend on liblxc1, so it can be built for any architecture
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Suggests: bash-completion
Built-Using: ${misc:Built-Using}
Description: Powerful system container and virtual machine manager - client
 Incus is a next generation system container and virtual machine manager.
 It offers a unified user experience around full Linux systems running
 inside containers or virtual machines.
 .
 A REST API is offered by Incus to remotely manage containers over the network,
 using an image based work-flow and with support for live migration.
 .
 This package contains the Incus command line client.

Package: incus-tools
Architecture: linux-any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Built-Using: ${misc:Built-Using}
# lxd-tools also ships a `fuidshift` binary; we expect src:lxd to only provide bin:golang-github-canonical-lxd-dev after the trixie release, so just use a simple Conflicts here
Conflicts: lxd-tools
Description: Powerful system container and virtual machine manager - extra tools
 Incus is a next generation system container and virtual machine manager.
 It offers a unified user experience around full Linux systems running
 inside containers or virtual machines.
 .
 This package contains extra tools provided with Incus.
  - fuidshift - A tool to map/unmap filesystem uids/gids
  - lxc-to-incus - A tool to migrate LXC containers to Incus
  - lxd-to-incus - A tool to migrate LXD containers to Incus
  - incus-benchmark - A benchmarking tool for Incus
  - incus-simplestreams - Maintain an Incus-compatible simplestreams tree

Package: incus-migrate
Architecture: linux-any
Depends: ${misc:Depends},
         ${shlibs:Depends},
         rsync
Built-Using: ${misc:Built-Using}
Description: Incus physical to instance migration tool
 This tool lets you turn any Linux filesystem (including your current one)
 into a Incus instance on a remote Incus host.
 .
 It will setup a clean mount tree made of the root filesystem and any
 additional mount you list, then transfer this through Incus's migration
 API to create a new instance from it.

Package: incus-agent
Architecture: linux-any
Depends: ${misc:Depends}
Built-Using: ${misc:Built-Using}
Description: Incus guest agent
 This package provides an agent to run inside Incus virtual machine guests.
 .
 It has to be installed on the Incus host if you want to allow agent
 injection capability when creating a virtual machine.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# Don't build binaries we don't ship
# NOTE -- incus-agent is listed here, as it is compiled as a statically-linked binary below
export DH_GOLANG_EXCLUDES := deps dev_incus-client generate sysinfo test/mini-oidc test/tls2jwt incus-agent

# Include various test and other support files
export DH_GOLANG_INSTALL_EXTRA := test/ shared/subprocess/testscript/ internal/server/instance/drivers/agent-loader/ internal/server/metadata/configuration.json

%:
	dh $@ --builddirectory=_build --buildsystem=golang --with=golang

override_dh_auto_build:
	# Build almost everything with dynamic linking
	CGO_LDFLAGS_ALLOW="-Wl,-z,now" dh_auto_build

	# Build incus-agent as a statically-linked binary
	CGO_LDFLAGS_ALLOW="-Wl,-z,now" CGO_ENABLED=0 DH_GOLANG_BUILDPKG="github.com/lxc/incus/cmd/incus-agent" DH_GOLANG_EXCLUDES="" dh_auto_build

	# Generate the man pages
	mkdir man1/
	TZ=UTC HOME="~" _build/bin/incus manpage man1/
	TZ=UTC HOME="~" _build/bin/incusd manpage man1/
	TZ=UTC HOME="~" help2man _build/bin/fuidshift -n "uid/gid shifter" --no-info --no-discard-stderr --version-string=$(DEB_VERSION_UPSTREAM) > man1/fuidshift.1
	TZ=UTC HOME="~" help2man _build/bin/lxc-to-incus -n "Convert LXC containers to Incus" --no-info --no-discard-stderr --version-string=$(DEB_VERSION_UPSTREAM) > man1/lxc-to-incus.1
	TZ=UTC HOME="~" help2man _build/bin/lxd-to-incus -n "Convert LXD containers to Incus" --no-info --no-discard-stderr --version-string=$(DEB_VERSION_UPSTREAM) > man1/lxd-to-incus.1
	TZ=UTC HOME="~" help2man _build/bin/incus-agent -n "Incus virtual machine guest agent" --no-info --no-discard-stderr --version-string=$(DEB_VERSION_UPSTREAM) > man1/incus-agent.1
	TZ=UTC HOME="~" help2man _build/bin/incus-benchmark -n "Incus benchmark" --no-info --no-discard-stderr --version-string=$(DEB_VERSION_UPSTREAM) > man1/incus-benchmark.1
	TZ=UTC HOME="~" help2man _build/bin/incus-migrate -n "Incus physical to instance migration tool" --no-info --no-discard-stderr --version-string=$(DEB_VERSION_UPSTREAM) > man1/incus-migrate.1
	TZ=UTC HOME="~" help2man _build/bin/incus-simplestreams -n "Maintain an Incus-compatible simplestreams tree" --no-info --no-discard-stderr --version-string=$(DEB_VERSION_UPSTREAM) > man1/incus-simplestreams.1
	TZ=UTC HOME="~" help2man _build/bin/incus-user -n "Incus user project daemon" --no-info --no-discard-stderr --version-string=$(DEB_VERSION_UPSTREAM) > man1/incus-user.1

	# Generate shell completions
	mkdir completions/
	_build/bin/incus completion bash > completions/incus
	_build/bin/incus completion fish > completions/incus.fish
	_build/bin/incus completion zsh > completions/_incus

override_dh_auto_test:
	CGO_LDFLAGS_ALLOW="-Wl,-z,now" dh_auto_test

override_dh_auto_install:
	DH_GOLANG_EXCLUDES="" dh_auto_install

	# Don't package python script
	find ./debian -name import-busybox -delete

	# Need to rename various config files here, as dh_install cannot rename files
	install -Dpm 0644 debian/incus.dnsmasq debian/tmp/etc/dnsmasq.d-available/incus
	install -Dpm 0644 debian/incus.logrotate debian/tmp/etc/logrotate.d/incus
	install -Dpm 0644 debian/incus.sysctl debian/tmp/etc/sysctl.d/10-incus-inotify.conf

override_dh_install:
	dh_install
	dh_installsysusers

override_dh_installsystemd:
	# Handle start / restart manually in incus.postinst
	dh_installsystemd --no-stop-on-upgrade --no-restart-after-upgrade --no-start

=== debian/watch ===
# For Debian packaging, only search for newer LTS releases, which have versions like <major>.0.<patch>
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%,\
      uversionmangle=s/(\d)[_\.\-\+]?(RC|rc|pre|dev|beta|alpha)[.]?(\d*)$/$1~$2$3/" \
  https://github.com/lxc/incus/tags .*/v(\d\.\d\.\d)\.tar\.gz debian

## incus 6.0.1

=== Makefile ===
--- 
+++ 
@@ -94,12 +94,10 @@
 	exit 1
 endif
 	$(GO) get -t -v -d -u ./...
-	$(GO) get github.com/cenkalti/rpc2@v1.0.1
+	$(GO) get github.com/go-acme/lego/v4@v4.16.1
 	$(GO) mod tidy --go=1.21
 	$(GO) get toolchain@none
 
-	cd test/mini-oidc && $(GO) get -t -v -d -u ./...
-	cd test/mini-oidc && $(GO) mod tidy --go=1.21
 	@echo "Dependencies updated"
 
 .PHONY: update-ovsdb

=== debian/changelog ===
incus (6.0.1-3) unstable; urgency=medium

  * Team upload.
  * Upload to unstable

 -- Reinhard Tartler <siretart@tauware.de>  Sat, 17 Aug 2024 07:21:34 -0400

incus (6.0.1-2) experimental; urgency=medium

  * Team upload.
  * Compile against go-criu v7, Closes: #1078217

 -- Reinhard Tartler <siretart@tauware.de>  Thu, 08 Aug 2024 19:01:26 -0400

incus (6.0.1-1) unstable; urgency=medium

  * New upstream release
    - Rebase d/p/002-adjust-import-paths.patch
  * d/control:
    - Update Build-Depends and Depends
    - Add minio-client to the list of incus' Recommended packages
  * Update d/watch for upstream's LTS tagging convention

 -- Mathias Gibbens <gibmat@debian.org>  Sat, 29 Jun 2024 02:08:43 +0000

=== debian/control ===
--- 
+++ 
@@ -8,13 +8,16 @@
                dh-golang,
                golang-any (>= 2:1.21~),
                golang-github-armon-go-proxyproto-dev,
-               golang-github-checkpoint-restore-go-criu-dev (>= 6.3.0),
+               golang-github-cenkalti-backoff-dev,
+               golang-github-checkpoint-restore-go-criu-dev (>= 7),
                golang-github-cowsql-go-cowsql-dev,
                golang-github-digitalocean-go-qemu-dev,
                golang-github-digitalocean-go-smbios-dev,
                golang-github-dustinkirkland-golang-petname-dev,
                golang-github-flosch-pongo2.v4-dev,
                golang-github-fvbommel-sortorder-dev,
+               golang-github-go-chi-chi-dev,
+               golang-github-go-jose-go-jose-dev,
                golang-github-go-logr-logr-dev,
                golang-github-golang-jwt-jwt-v5-dev,
                golang-github-golang-protobuf-1-5-dev,
@@ -33,7 +36,6 @@
                golang-github-mdlayher-netx-dev,
                golang-github-mdlayher-vsock-dev,
                golang-github-miekg-dns-dev,
-               golang-github-minio-madmin-go-dev (>= 3.0.38),
                golang-github-minio-minio-go-v7-dev,
                golang-github-mitchellh-mapstructure-dev,
                golang-github-olekukonko-tablewriter-dev,
@@ -53,6 +55,7 @@
                golang-github-zitadel-oidc-dev (>= 3.0),
                golang-gocapability-dev,
                golang-golang-x-crypto-dev,
+               golang-golang-x-exp-dev,
                golang-golang-x-oauth2-dev,
                golang-golang-x-sync-dev,
                golang-golang-x-sys-dev,
@@ -80,13 +83,16 @@
 Multi-Arch: foreign
 Section: golang
 Depends: golang-github-armon-go-proxyproto-dev,
-         golang-github-checkpoint-restore-go-criu-dev (>= 6.3.0),
+         golang-github-cenkalti-backoff-dev,
+         golang-github-checkpoint-restore-go-criu-dev (>= 7),
          golang-github-cowsql-go-cowsql-dev,
          golang-github-digitalocean-go-qemu-dev,
          golang-github-digitalocean-go-smbios-dev,
          golang-github-dustinkirkland-golang-petname-dev,
          golang-github-flosch-pongo2.v4-dev,
          golang-github-fvbommel-sortorder-dev,
+         golang-github-go-chi-chi-dev,
+         golang-github-go-jose-go-jose-dev,
          golang-github-go-logr-logr-dev,
          golang-github-golang-jwt-jwt-v5-dev,
          golang-github-golang-protobuf-1-5-dev,
@@ -105,7 +111,6 @@
          golang-github-mdlayher-netx-dev,
          golang-github-mdlayher-vsock-dev,
          golang-github-miekg-dns-dev,
-         golang-github-minio-madmin-go-dev (>= 3.0.38),
          golang-github-minio-minio-go-v7-dev,
          golang-github-mitchellh-mapstructure-dev,
          golang-github-olekukonko-tablewriter-dev,
@@ -125,6 +130,7 @@
          golang-github-zitadel-oidc-dev (>= 3.0),
          golang-gocapability-dev,
          golang-golang-x-crypto-dev,
+         golang-golang-x-exp-dev,
          golang-golang-x-oauth2-dev,
          golang-golang-x-sync-dev,
          golang-golang-x-sys-dev,
@@ -161,7 +167,7 @@
          squashfs-tools,
          uidmap,
          xz-utils
-Recommends: apparmor, dnsmasq-base, incus-agent
+Recommends: apparmor, dnsmasq-base, incus-agent, minio-client
 # First line of suggested packages will enable additional Incus storage backends
 Suggests: btrfs-progs, ceph-common, lvm2, zfsutils-linux,
           incus-tools, gdisk

## incus 6.0.2

=== Makefile ===
--- 
+++ 
@@ -93,9 +93,8 @@
 	@echo "The update-gomod target cannot be run in offline mode."
 	exit 1
 endif
-	$(GO) get -t -v -d -u ./...
-	$(GO) get github.com/go-acme/lego/v4@v4.16.1
-	$(GO) mod tidy --go=1.21
+	$(GO) get -t -v -u ./...
+	$(GO) mod tidy --go=1.22.0
 	$(GO) get toolchain@none
 
 	@echo "Dependencies updated"
@@ -312,7 +311,7 @@
 	flake8 test/deps/import-busybox
 	shellcheck --shell sh test/*.sh test/includes/*.sh test/suites/*.sh test/backends/*.sh test/lint/*.sh
 	shellcheck test/extras/*.sh
-	run-parts --exit-on-error --regex '.sh' test/lint
+	run-parts $(shell run-parts -V >/dev/null 2>&1 && echo -n "--verbose --exit-on-error --regex '.sh'") test/lint
 
 .PHONY: staticcheck
 staticcheck:

=== doc/.sphinx/requirements.txt ===
furo
gitpython
linkify-it-py
lxd-sphinx-extensions
myst-parser<3.0.0
pyspelling
sphinx
sphinx-autobuild
sphinx-copybutton
sphinx-design
sphinx-notfound-page
sphinx-remove-toctrees
sphinx-reredirects
sphinx-tabs
sphinxcontrib-jquery
sphinxext-opengraph

=== debian/changelog ===
incus (6.0.2-1+rpi1) trixie-staging; urgency=medium

  * Disable testsuite.

 -- Peter Michael Green <plugwash@raspbian.org>  Thu, 26 Sep 2024 15:25:21 +0000

incus (6.0.2-1) unstable; urgency=medium

  * New upstream release
    - Rebase d/p/002-adjust-import-paths.patch
  * d/control:
    - Bump minimum required version of golang-any to 1.22 per go.mod
    - Set minimum required version of golang-github-openfga-go-sdk

 -- Mathias Gibbens <gibmat@debian.org>  Thu, 19 Sep 2024 03:05:28 +0000

=== debian/control ===
--- 
+++ 
@@ -6,7 +6,7 @@
 Priority: optional
 Build-Depends: debhelper-compat (= 13),
                dh-golang,
-               golang-any (>= 2:1.21~),
+               golang-any (>= 2:1.22~),
                golang-github-armon-go-proxyproto-dev,
                golang-github-cenkalti-backoff-dev,
                golang-github-checkpoint-restore-go-criu-dev (>= 7),
@@ -39,7 +39,7 @@
                golang-github-minio-minio-go-v7-dev,
                golang-github-mitchellh-mapstructure-dev,
                golang-github-olekukonko-tablewriter-dev,
-               golang-github-openfga-go-sdk-dev,
+               golang-github-openfga-go-sdk-dev (>= 0.6.0),
                golang-github-osrg-gobgp-dev (>= 3.10.0),
                golang-github-ovn-org-libovsdb-dev,
                golang-github-pierrec-lz4-dev (>= 4.1.18),
@@ -114,7 +114,7 @@
          golang-github-minio-minio-go-v7-dev,
          golang-github-mitchellh-mapstructure-dev,
          golang-github-olekukonko-tablewriter-dev,
-         golang-github-openfga-go-sdk-dev,
+         golang-github-openfga-go-sdk-dev (>= 0.6.0),
          golang-github-osrg-gobgp-dev (>= 3.10.0),
          golang-github-ovn-org-libovsdb-dev,
          golang-github-pierrec-lz4-dev (>= 4.1.18),

=== debian/rules ===
--- 
+++ 
@@ -41,7 +41,7 @@
 	_build/bin/incus completion zsh > completions/_incus
 
 override_dh_auto_test:
-	CGO_LDFLAGS_ALLOW="-Wl,-z,now" dh_auto_test
+	#CGO_LDFLAGS_ALLOW="-Wl,-z,now" dh_auto_test
 
 override_dh_auto_install:
 	DH_GOLANG_EXCLUDES="" dh_auto_install

## incus 6.0.3

=== Makefile ===
--- 
+++ 
@@ -94,7 +94,7 @@
 	exit 1
 endif
 	$(GO) get -t -v -u ./...
-	$(GO) mod tidy --go=1.22.0
+	$(GO) mod tidy --go=1.22.7
 	$(GO) get toolchain@none
 
 	@echo "Dependencies updated"
@@ -331,4 +331,4 @@
 # OpenFGA Syntax Transformer: https://github.com/openfga/syntax-transformer
 .PHONY: update-openfga
 update-openfga:
-	@printf 'package auth\n\n// Code generated by Makefile; DO NOT EDIT.\n\nvar authModel = `%s`\n' '$(shell npx --yes @openfga/syntax-transformer transform --from=dsl --inputFile=./internal/server/auth/driver_openfga_model.openfga | jq -c)' > ./internal/server/auth/driver_openfga_model.go
+	@printf 'package auth\n\n// Code generated by Makefile; DO NOT EDIT.\n\nvar authModel = `%s`\n' '$(shell fga model transform --file=./internal/server/auth/driver_openfga_model.openfga | jq -c)' > ./internal/server/auth/driver_openfga_model.go

=== debian/changelog ===
incus (6.0.3-4) unstable; urgency=medium

  * d/control:
    - Update Standards-Version to 4.7.2 (no changes needed)
    - Limit virtiofsd dependency to 64bit architectures
    - Set minimum required version of qemu
  * Cherry-pick upstream fix to allow virtiofsd on non-x86 architectures

 -- Mathias Gibbens <gibmat@debian.org>  Sun, 02 Mar 2025 23:07:28 +0000

incus (6.0.3-3) unstable; urgency=medium

  * Update organization of binary packages:
    - bin:incus provides all dependencies to run both containers and VMs
    - bin:incus-base has just what is necessary for running containers
    - bin:incus-tools and bin:incus-migrate combined into bin:incus-extra

 -- Mathias Gibbens <gibmat@debian.org>  Sat, 01 Mar 2025 17:16:21 +0000

incus (6.0.3-2) unstable; urgency=medium

  [ Kwok Guy ]
  * Initial SysV init scripts for incus

  [ Mathias Gibbens ]
  * Update years in d/copyright
  * Update d/README.Debian
  * Cherry-pick upstream fix to remove virtfs-proxy-helper dependency
  * Cherry-pick upstream fix for qemu device_id warning
  * Add startup wrapper script to allow directing logging to syslog
  * Add a patch to adjust the MinIO client's binary name to reflect Debian
    packaging

 -- Mathias Gibbens <gibmat@debian.org>  Sun, 26 Jan 2025 01:19:17 +0000

incus (6.0.3-1) unstable; urgency=medium

  * New upstream release (Closes: #1090375)
    - Includes fix for CVE-2024-6156
    - Rebase d/p/002-adjust-import-paths.patch
  * d/control:
    - Set minimum required version of golang-starlark-dev
    - Adjust recommended and suggested packages
  * Mention the swtpm-tools package in d/README.Debian

 -- Mathias Gibbens <gibmat@debian.org>  Fri, 20 Dec 2024 02:44:01 +0000

=== debian/control ===
--- 
+++ 
@@ -66,12 +66,12 @@
                golang-gopkg-tomb.v2-dev,
                golang-gopkg-yaml.v2-dev,
                golang-k8s-utils-dev,
-               golang-starlark-dev,
+               golang-starlark-dev (>= 0.0~git20240725.42030a7),
                help2man,
                libacl1-dev,
                libcap-dev
 Build-Conflicts: golang-github-golang-protobuf-1-3-dev
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Vcs-Browser: https://salsa.debian.org/go-team/packages/incus
 Vcs-Git: https://salsa.debian.org/go-team/packages/incus.git
 Homepage: https://linuxcontainers.org/incus/
@@ -141,7 +141,7 @@
          golang-gopkg-tomb.v2-dev,
          golang-gopkg-yaml.v2-dev,
          golang-k8s-utils-dev,
-         golang-starlark-dev,
+         golang-starlark-dev (>= 0.0~git20240725.42030a7),
          ${misc:Depends}
 Description: Powerful system container and virtual machine manager - library
  Incus is a next generation system container and virtual machine manager.
@@ -153,7 +153,36 @@
  their regular development workflow. Rather, they should use `go get`.
 
 Package: incus
-Architecture: linux-any
+# Technically this package is arch:all, but to use architecture restrictions for
+# the qemu-system-* dependencies, we must use a variant of arch:any
+Architecture: linux-any
+Depends: ${misc:Depends},
+         incus-agent (= ${binary:Version}),
+         incus-base (= ${binary:Version}),
+         qemu-system-arm (>= 1:8.0) [arm64 armel armhf],
+         qemu-system-mips (>= 1:8.0) [mips64el],
+         qemu-system-ppc (>= 1:8.0) [ppc64el],
+         qemu-system-riscv (>= 1:8.0) [riscv64],
+         qemu-system-s390x (>= 1:8.0) [s390x],
+         qemu-system-x86 (>= 1:8.0) [amd64 i386],
+         swtpm,
+         virtiofsd [!armel !armhf !i386]
+Suggests: gdisk
+Built-Using: ${misc:Built-Using}
+Description: Powerful system container and virtual machine manager - daemon
+ Incus is a next generation system container and virtual machine manager.
+ It offers a unified user experience around full Linux systems running
+ inside containers or virtual machines.
+ .
+ It's image based with pre-made images available for a wide number of
+ Linux distributions and is built around a very powerful, yet pretty
+ simple, REST API.
+ .
+ This metapackage will install everything needed to run containers and VMs.
+
+Package: incus-base
+Architecture: linux-any
+Pre-Depends: ${misc:Pre-Depends}
 Depends: ${misc:Depends},
          ${shlibs:Depends},
          attr,
@@ -167,12 +196,15 @@
          squashfs-tools,
          uidmap,
          xz-utils
-Recommends: apparmor, dnsmasq-base, incus-agent, minio-client
+Recommends: apparmor, dnsmasq-base
 # First line of suggested packages will enable additional Incus storage backends
+# Second line lists additional optional tools
 Suggests: btrfs-progs, ceph-common, lvm2, zfsutils-linux,
-          incus-tools, gdisk
-Built-Using: ${misc:Built-Using}
-Description: Powerful system container and virtual machine manager - daemon
+          incus-extra, minio-client
+Built-Using: ${misc:Built-Using}
+Breaks: incus (<< 6.0.3-3~)
+Replaces: incus (<< 6.0.3-3~)
+Description: Powerful system container and virtual machine manager - daemon (container-only)
  Incus is a next generation system container and virtual machine manager.
  It offers a unified user experience around full Linux systems running
  inside containers or virtual machines.
@@ -181,7 +213,7 @@
  Linux distributions and is built around a very powerful, yet pretty
  simple, REST API.
  .
- This package contains the Incus daemon.
+ This package contains only what is needed to run containers.
 
 Package: incus-client
 # The incus binary doesn't depend on liblxc1, so it can be built for any architecture
@@ -200,12 +232,17 @@
  .
  This package contains the Incus command line client.
 
-Package: incus-tools
-Architecture: linux-any
-Depends: ${misc:Depends},
-         ${shlibs:Depends}
-Built-Using: ${misc:Built-Using}
-# lxd-tools also ships a `fuidshift` binary; we expect src:lxd to only provide bin:golang-github-canonical-lxd-dev after the trixie release, so just use a simple Conflicts here
+Package: incus-extra
+Architecture: linux-any
+Depends: ${misc:Depends},
+         ${shlibs:Depends},
+         rsync
+Built-Using: ${misc:Built-Using}
+Breaks: incus-tools (<< 6.0.3-3~),
+        incus-migrate (<< 6.0.3-3~)
+Replaces: incus-tools (<< 6.0.3-3~),
+          incus-migrate (<< 6.0.3-3~)
+# lxd-tools also ships a `fuidshift` binary; we expect src:lxd to be RM'ed after the trixie release, so just use a simple Conflicts here
 Conflicts: lxd-tools
 Description: Powerful system container and virtual machine manager - extra tools
  Incus is a next generation system container and virtual machine manager.
@@ -217,21 +254,8 @@
   - lxc-to-incus - A tool to migrate LXC containers to Incus
   - lxd-to-incus - A tool to migrate LXD containers to Incus
   - incus-benchmark - A benchmarking tool for Incus
+  - incus-migrate - A tool to turn any filesystem into an Incus instance
   - incus-simplestreams - Maintain an Incus-compatible simplestreams tree
-
-Package: incus-migrate
-Architecture: linux-any
-Depends: ${misc:Depends},
-         ${shlibs:Depends},
-         rsync
-Built-Using: ${misc:Built-Using}
-Description: Incus physical to instance migration tool
- This tool lets you turn any Linux filesystem (including your current one)
- into a Incus instance on a remote Incus host.
- .
- It will setup a clean mount tree made of the root filesystem and any
- additional mount you list, then transfer this through Incus's migration
- API to create a new instance from it.
 
 Package: incus-agent
 Architecture: linux-any

=== debian/rules ===
--- 
+++ 
@@ -41,7 +41,7 @@
 	_build/bin/incus completion zsh > completions/_incus
 
 override_dh_auto_test:
-	#CGO_LDFLAGS_ALLOW="-Wl,-z,now" dh_auto_test
+	CGO_LDFLAGS_ALLOW="-Wl,-z,now" dh_auto_test
 
 override_dh_auto_install:
 	DH_GOLANG_EXCLUDES="" dh_auto_install
@@ -50,14 +50,22 @@
 	find ./debian -name import-busybox -delete
 
 	# Need to rename various config files here, as dh_install cannot rename files
-	install -Dpm 0644 debian/incus.dnsmasq debian/tmp/etc/dnsmasq.d-available/incus
-	install -Dpm 0644 debian/incus.logrotate debian/tmp/etc/logrotate.d/incus
-	install -Dpm 0644 debian/incus.sysctl debian/tmp/etc/sysctl.d/10-incus-inotify.conf
+	install -Dpm 0644 debian/incus-base.dnsmasq debian/tmp/etc/dnsmasq.d-available/incus
+	install -Dpm 0644 debian/incus-base.sysctl debian/tmp/etc/sysctl.d/10-incus-inotify.conf
 
 override_dh_install:
 	dh_install
-	dh_installsysusers
+	dh_installlogrotate --name incus
+	dh_installsysusers --name incus
+
+override_dh_installinit:
+	dh_installinit --name incus
+	dh_installinit --name incus-user --no-stop-on-upgrade --no-restart-after-upgrade
+	dh_installinit --name incus-startup --no-stop-on-upgrade --no-restart-after-upgrade
 
 override_dh_installsystemd:
 	# Handle start / restart manually in incus.postinst
-	dh_installsystemd --no-stop-on-upgrade --no-restart-after-upgrade --no-start
+	dh_installsystemd --name incus-startup --no-stop-on-upgrade --no-restart-after-upgrade --no-start
+	dh_installsystemd --name incus --no-stop-on-upgrade --no-restart-after-upgrade --no-start
+	dh_installsystemd --name incus-user --no-stop-on-upgrade --no-restart-after-upgrade --no-start
+	dh_installsystemd --name incus-agent --no-stop-on-upgrade --no-restart-after-upgrade --no-start
